include fuzzy.e
include machine.e
without type_check

constant OLD   = {18,65}   --person age in years
constant HEAVY = {100,300} --person weight in pounds
constant WHITE = {{190,190,190},{240,240,240}} --range that white is

--------------------------------------------------------------
function RealRand(atom limit)
   return rand(limit) + (rand(10000)/10000)
end function

procedure Pause()
   puts(1,"\nPress a Key <ctrl-c quits>")
   while get_key()=-1 do end while
   puts(1,"\r                                 \r")
end procedure

procedure runbench(sequence seq1, sequence seq2, integer which)
atom now
sequence result
   result = {}
   if    which = 1 then
         now=time()
         result=FindTruthAtom(seq1,HEAVY)
         now=time()-now
   elsif which = 2 then
         now=time()
         result=FuzzyANDAtom(seq1,HEAVY,seq2,OLD)
         now=time()-now
   else
         now=time()
         result=FuzzyANDSeq(seq1,WHITE,seq2,WHITE)
         now=time()-now
   end if
   printf(1,"%10.6f",now)
end procedure

procedure bench(integer quan,integer len,integer loops,integer which)
sequence seq1,seq2,temp1,temp2
   --create fresh data to ensure NO caching from before
   temp1=repeat(0,len)   seq1=repeat(0,quan)
   if    which =1 then
         for j= 1 to len do
           temp1[j]=rand(500)+(rand(1000)/1000) 
         end for
   elsif which =2 then
         temp2=temp1
         for j= 1 to len do
           temp1[j]=rand(500)+(rand(1000)/1000)
           temp2[j]=rand(100)+(rand(1000)/1000)
         end for
   else  for j= 1 to len do
            temp1[j]=rand({255,255,255})
         end for
         temp2=temp1-rand(4) --adjust pixel values across the board
   end if
   for i= 1 to quan do
     seq1[i]=temp1
   end for
   if which > 1 then 
      seq2=repeat(0,quan)
      for i= 1 to quan do
        seq2[i]=temp2
      end for
      --shift to make them not equal
      --seq2=append(seq1[2..length(seq1)],seq1[1])
   end if
   temp1={} temp2={} --reuse memory
   if   which =1 then
        printf(1,"FindTruth %5dx%5d seq:",{quan,len})
        for loop=1 to loops do runbench(seq1,  {},which) end for
   else printf(1,"FuzzyAND  %5dx%5d seq:",{quan,len})
        for loop=1 to loops do runbench(seq1,seq2,which) end for
   end if
   Pause()
end procedure
--------------------------------------------------------------

tick_rate(1000)
--clear_screen()
bench(10,10000,4,1) --10  regions of 10000 responses per region

bench(500,500,4,1)  --500 regions of 500   responses per region

bench(10,5000,4,2)  --10  regions of 5000  responses per region
                    --that asks the question "who is big and old"

bench(250,250,4,2)  --500 regions of 500   responses per region
                    --that asks the question "who is big and old"

--now a 200 line, 320 width, 16.7m image VS another image
--(equal to a 640 length sequence of 400 length sequences)
bench(200,320,4,3)


